package com.ccnode.codegenerator.ai;

package .tmp;

import com.ccnode.codegenerator.U.o;
import com.ccnode.codegenerator.ae.D;
import com.ccnode.codegenerator.ae.W;
import com.ccnode.codegenerator.ae.f;
import com.ccnode.codegenerator.ai.a;
import com.ccnode.codegenerator.ai.d;
import com.ccnode.codegenerator.ai.g;
import com.ccnode.codegenerator.ai.j;
import com.ccnode.codegenerator.k.a;
import com.ccnode.codegenerator.l.d;
import com.ccnode.codegenerator.myconfigurable.Profile;
import com.ccnode.codegenerator.myconfigurable.ProjectProfile;
import com.ccnode.codegenerator.typemapper.DollarMapper;
import com.ccnode.codegenerator.view.C;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.google.common.collect.Sets;
import com.intellij.lang.Language;
import com.intellij.lang.injection.MultiHostInjector;
import com.intellij.lang.injection.MultiHostRegistrar;
import com.intellij.openapi.application.ApplicationManager;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.util.TextRange;
import com.intellij.openapi.vfs.VirtualFile;
import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiFile;
import com.intellij.psi.impl.source.xml.XmlTextImpl;
import com.intellij.psi.xml.XmlAttribute;
import com.intellij.psi.xml.XmlAttributeValue;
import com.intellij.psi.xml.XmlFile;
import com.intellij.psi.xml.XmlTag;
import com.intellij.psi.xml.XmlTagValue;
import com.intellij.sql.dialects.mysql.MysqlDialect;
import com.intellij.sql.psi.SqlLanguage;
import com.intellij.util.ObjectUtils;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import org.apache.commons.lang3.StringUtils;
import org.jetbrains.annotations.NotNull;

public class e implements MultiHostInjector {
  public static final String a = "trim";
  
  public static final String b = "prefixOverrides";
  
  public static final String c = "suffixOverrides";
  
  public void getLanguagesToInject(@NotNull MultiHostRegistrar paramMultiHostRegistrar, @NotNull PsiElement paramPsiElement) {
    Profile profile = a.a();
    boolean bool = profile.getValid();
    if (!bool)
      return; 
    if (paramPsiElement instanceof XmlTag) {
      String str = ((XmlTag)paramPsiElement).getName();
      if (!d.b.contains(str))
        return; 
      XmlTag xmlTag1 = (XmlTag)ObjectUtils.tryCast(paramPsiElement, XmlTag.class);
      PsiFile psiFile = paramPsiElement.getContainingFile();
      if (!xmlTag1.isValid() || !psiFile.isValid())
        return; 
      boolean bool1 = D.a.a(psiFile);
      if (!bool1)
        return; 
      int i = psiFile.getTextLength();
      if (i > profile.getMaxParsingXmlTextLength())
        return; 
      VirtualFile virtualFile = psiFile.getVirtualFile();
      boolean bool2 = false;
      if (virtualFile != null) {
        o o = (o)virtualFile.getUserData(C.a);
        if (o != null && o.a()) {
          long l1 = System.currentTimeMillis();
          long l2 = a.a().getReformatLoadingTime();
          if (l1 > o.a() && l1 - o.a() < l2) {
            bool2 = true;
          } else {
            o.a(false);
            virtualFile.putUserData(C.a, o);
          } 
        } 
      } 
      if (profile.getTestWithFormatter())
        bool2 = true; 
      if (!bool2)
        Date date = new Date(); 
      XmlTag xmlTag2 = (XmlTag)paramPsiElement;
      if (str.equals("sql")) {
        a(paramMultiHostRegistrar, xmlTag2, psiFile, bool2);
        return;
      } 
      if (!d.a.contains(str))
        return; 
      if (StringUtils.isBlank(xmlTag2.getText()))
        return; 
      PsiElement[] arrayOfPsiElement = xmlTag2.getChildren();
      g g = new g();
      g.a(bool2);
      g.a(xmlTag1);
      boolean bool3 = a.a().getDollarMappingInXmlComment();
      ProjectProfile projectProfile = com.ccnode.codegenerator.view.e.e.a(psiFile.getProject());
      List list = projectProfile.getDollarMappers();
      if (f.b(list))
        for (DollarMapper dollarMapper : list)
          g.a().put(dollarMapper.getDollarName(), dollarMapper.getDollarValue());  
      if (bool3)
        g.a().putAll(D.a.b(xmlTag2)); 
      List<d> list1 = j.a(arrayOfPsiElement, g, true);
      if (list1.size() == 0)
        return; 
      if (bool2) {
        for (byte b = 0; b < list1.size(); b++) {
          d d = list1.get(b);
          if (!(d.a() instanceof com.intellij.psi.xml.XmlComment)) {
            StringBuilder stringBuilder1 = new StringBuilder();
            StringBuilder stringBuilder2 = new StringBuilder();
            int j;
            for (j = 0; j < b; j++) {
              d d1 = list1.get(j);
              String str1 = d1.c();
              stringBuilder1.append(str1);
            } 
            stringBuilder1.append(d.a());
            stringBuilder2.append(d.b());
            for (j = b + 1; j < list1.size(); j++) {
              d d1 = list1.get(j);
              String str1 = d1.c();
              stringBuilder2.append(str1);
            } 
            MultiHostRegistrar multiHostRegistrar = null;
            if (ApplicationManager.getApplication().isUnitTestMode()) {
              multiHostRegistrar = paramMultiHostRegistrar.startInjecting((Language)MysqlDialect.INSTANCE);
            } else {
              multiHostRegistrar = paramMultiHostRegistrar.startInjecting((Language)SqlLanguage.INSTANCE);
            } 
            multiHostRegistrar.addPlace(D.a.f(stringBuilder1.toString()), D.a.f(stringBuilder2.toString()), d.a(), new TextRange(d.a().a(), d
                  .a().b()));
            multiHostRegistrar.doneInjecting();
          } 
        } 
      } else {
        MultiHostRegistrar multiHostRegistrar = null;
        if (ApplicationManager.getApplication().isUnitTestMode()) {
          multiHostRegistrar = paramMultiHostRegistrar.startInjecting((Language)MysqlDialect.INSTANCE);
        } else {
          multiHostRegistrar = paramMultiHostRegistrar.startInjecting((Language)SqlLanguage.INSTANCE);
        } 
        for (d d : list1)
          multiHostRegistrar.addPlace(d.a(), d.b(), d
              .a(), new TextRange(d.a().a(), d
                .a().b())); 
        multiHostRegistrar.doneInjecting();
      } 
      a(paramMultiHostRegistrar, xmlTag2, bool2);
    } 
  }
  
  private void a(@NotNull MultiHostRegistrar paramMultiHostRegistrar, XmlTag paramXmlTag, boolean paramBoolean) {
    (new Object(this, paramBoolean, paramMultiHostRegistrar))















































      
      .visitXmlTag(paramXmlTag);
  }
  
  private void a(MultiHostRegistrar paramMultiHostRegistrar, XmlTag paramXmlTag, PsiFile paramPsiFile, boolean paramBoolean) {
    String str1 = paramXmlTag.getText();
    if (StringUtils.isBlank(str1))
      return; 
    if (!(paramPsiFile instanceof XmlFile))
      return; 
    ArrayList<XmlFile> arrayList = Lists.newArrayList(new XmlFile[] { (XmlFile)paramPsiFile });
    String str2 = D.a.a(arrayList);
    PsiElement[] arrayOfPsiElement = paramXmlTag.getChildren();
    g g = new g();
    g.a(paramBoolean);
    g.a(paramXmlTag);
    boolean bool = a.a().getDollarMappingInXmlComment();
    ProjectProfile projectProfile = com.ccnode.codegenerator.view.e.e.a(paramPsiFile.getProject());
    List list = projectProfile.getDollarMappers();
    if (f.b(list))
      for (DollarMapper dollarMapper : list)
        g.a().put(dollarMapper.getDollarName(), dollarMapper.getDollarValue());  
    if (bool)
      g.a().putAll(D.a.b(paramXmlTag)); 
    List<d> list1 = j.a(arrayOfPsiElement, g, true);
    if (list1.size() == 0)
      return; 
    StringBuilder stringBuilder = new StringBuilder();
    boolean bool1 = true;
    for (d d : list1) {
      String str = d.c();
      if (d.a() instanceof com.intellij.psi.impl.source.xml.XmlCommentImpl)
        bool1 = false; 
      stringBuilder.append(str);
    } 
    String str3 = stringBuilder.toString().trim().toLowerCase();
    if (projectProfile.getAutoInjectPrefixAndSuffixForSqlTag()) {
      a a = a(paramXmlTag);
      if (a.a()) {
        bool1 = false;
        ((d)list1.get(0)).d(a.a());
        if (StringUtils.isNotBlank(str2))
          ((d)list1.get(list1.size() - 1)).e(a.b()); 
      } 
    } 
    if (bool1 && a(str3))
      bool1 = false; 
    if (bool1) {
      ((d)list1.get(0)).d("select ");
      if (StringUtils.isNotBlank(str2))
        ((d)list1.get(list1.size() - 1)).e(" from " + str2); 
    } 
    if (paramBoolean) {
      for (byte b = 0; b < list1.size(); b++) {
        d d = list1.get(b);
        if (!(d.a() instanceof com.intellij.psi.xml.XmlComment)) {
          StringBuilder stringBuilder1 = new StringBuilder();
          StringBuilder stringBuilder2 = new StringBuilder();
          int i;
          for (i = 0; i < b; i++) {
            d d1 = list1.get(i);
            String str = d1.c();
            stringBuilder1.append(str);
          } 
          stringBuilder1.append(d.a());
          stringBuilder2.append(d.b());
          for (i = b + 1; i < list1.size(); i++) {
            d d1 = list1.get(i);
            String str = d1.c();
            stringBuilder2.append(str);
          } 
          MultiHostRegistrar multiHostRegistrar = null;
          if (ApplicationManager.getApplication().isUnitTestMode()) {
            multiHostRegistrar = paramMultiHostRegistrar.startInjecting((Language)MysqlDialect.INSTANCE);
          } else {
            multiHostRegistrar = paramMultiHostRegistrar.startInjecting((Language)SqlLanguage.INSTANCE);
          } 
          paramMultiHostRegistrar.addPlace(D.a.f(stringBuilder1.toString()), D.a.f(stringBuilder2.toString()), d.a(), new TextRange(d.a().a(), d
                .a().b()));
          multiHostRegistrar.doneInjecting();
        } 
      } 
    } else {
      MultiHostRegistrar multiHostRegistrar = paramMultiHostRegistrar.startInjecting((Language)SqlLanguage.INSTANCE);
      for (d d : list1)
        multiHostRegistrar.addPlace(d.a(), d.b(), d
            .a(), new TextRange(d.a().a(), d
              .a().b())); 
      multiHostRegistrar.doneInjecting();
    } 
    a(paramMultiHostRegistrar, paramXmlTag, paramBoolean);
  }
  
  public static a a(XmlTag paramXmlTag) {
    a a = new a();
    Project project = paramXmlTag.getProject();
    XmlAttribute xmlAttribute = paramXmlTag.getAttribute("id");
    if (xmlAttribute == null) {
      a.a(false);
      return a;
    } 
    XmlAttributeValue xmlAttributeValue = xmlAttribute.getValueElement();
    if (xmlAttributeValue == null) {
      a.a(false);
      return a;
    } 
    PsiFile psiFile = paramXmlTag.getContainingFile();
    XmlFile xmlFile = (XmlFile)psiFile;
    XmlTag[] arrayOfXmlTag = xmlFile.getRootTag().getSubTags();
    XmlTag xmlTag1 = null;
    XmlTag xmlTag2 = null;
    for (XmlTag xmlTag : arrayOfXmlTag) {
      String str = "refid=\"" + xmlAttributeValue.getValue() + "\"";
      boolean bool = xmlTag.getText().contains(str);
      if (bool) {
        xmlTag1 = xmlTag;
        int i = xmlTag.getText().indexOf(str);
        int j = xmlTag.getTextRange().getStartOffset();
        int k = j + i;
        PsiElement psiElement = xmlTag.getContainingFile().findElementAt(k);
        xmlTag2 = (XmlTag)psiElement.getParent().getParent();
        break;
      } 
    } 
    if (xmlTag1 == null) {
      a.a(false);
      return a;
    } 
    XmlTag xmlTag3 = xmlTag2;
    TextRange textRange1 = xmlTag3.getTextRange();
    XmlTagValue xmlTagValue = xmlTag1.getValue();
    String str1 = xmlTagValue.getText();
    TextRange textRange2 = xmlTagValue.getTextRange();
    HashMap<?, ?> hashMap = Maps.newHashMap();
    HashSet<?> hashSet = Sets.newHashSet();
    String str2 = W.a.a(xmlTag1.getChildren(), hashMap, hashSet, true, new TextRange(textRange2.getStartOffset(), textRange1.getStartOffset()));
    String str3 = W.a.a(xmlTag1.getChildren(), hashMap, hashSet, true, new TextRange(textRange1.getEndOffset(), textRange2.getEndOffset()));
    String str4 = " " + W.a.a(str3).trim() + " ";
    String str5 = " " + str2.trim() + " ";
    a.a(true);
    a.a(str5);
    a.b(str4);
    return a;
  }
  
  private boolean a(String paramString) {
    String str1 = D.a.e(paramString);
    String str2 = str1.trim();
    ArrayList<String> arrayList = Lists.newArrayList(new String[] { "insert", "update", "delete", "select", "begin" });
    for (String str : arrayList) {
      if (str2.startsWith(str))
        return true; 
    } 
    return false;
  }
  
  private XmlTag a(XmlTextImpl paramXmlTextImpl) {
    PsiElement psiElement = paramXmlTextImpl.getParent();
    while (psiElement != null) {
      boolean bool = psiElement instanceof XmlTag;
      if (bool) {
        XmlTag xmlTag = (XmlTag)psiElement;
        String str = xmlTag.getName();
        if (d.a.contains(str))
          return (XmlTag)psiElement; 
      } 
      psiElement = psiElement.getParent();
    } 
    return null;
  }
  
  @NotNull
  public List<? extends Class<? extends PsiElement>> elementsToInjectIn() {
    return Arrays.asList((Class<? extends PsiElement>[])new Class[] { XmlTag.class });
  }
}
